require 'sketchup.rb'

#select a point on a component and move to x,z plane
 class SetCompToFront #*****************************************************************

  def initialize
   @entity=nil
   @inpt=nil
   @tinpt=nil
   @ip=nil
  end
   
  #is called when first activated
  def activate
   @inpt = Sketchup::InputPoint.new           #set up Input point and temp and diplayed
   @tinpt= Sketchup::InputPoint.new
   @ip= Sketchup::InputPoint.new
   #@displayed = false

   #lets see if any componenent is already selected and clear selection set
   model=Sketchup.active_model
   @ss=model.selection
   @ss.clear
   @entity=nil   

   self.reset(nil)
  end 
  
   #is called if tool is deactivated because a different tool is selected
  def deactivate(view)
   view.invalidate 
  end

  #onCancel is called when user hits escape etc
  def onCancel(flag, view)
    if (flag==2)
     view.invalidate
    else
     self.reset(view)
    end
  end

 #reset to start over again
  def reset(view)
   @displayed=false
   @entity=nil
     Sketchup::set_status_text "Select point on component",SB_PROMPT
  end
  
   #cruise for a point in component
  def onMouseMove(flags, x, y, view)
    @tinpt.pick view, x, y
    if (@tinpt.valid?) 
      changed=@tinpt != @inpt
      @inpt.copy! @tinpt 
      view.tooltip = @tinpt.tooltip
      #display point
      if ( changed and (@inpt.display? or @displayed))
       view.invalidate 
      end
    end
  end
  
  def onLButtonDown(flags, x, y, view)
     ph=view.pick_helper
     ph.do_pick x,y
     @entity=ph.best_picked
	 oops=1
     if @entity
      type=@entity.typename
      if type=="ComponentInstance"
       oops=0
      end
     end
	 if oops==0
	  @ip.pick view,x,y
      oops=1
      if(@ip.valid?)
	   if (@ip.vertex)
        if (@entity.definition==@ip.vertex.parent) 
         oops=0
		end
	   end	
	  end 	
	 end		
	 if oops==1 
	  UI.messagebox "Selection invalid"
	 else
      pos=@ip.position
      newpos = Geom::Point3d.new 0, -pos.y, 0
	  trans = Geom::Transformation.new newpos
	  status = @entity.transform! trans
	  @entity=nil
	 end
  end
  
  #draw is called when we want to display the point
  def draw(view)
   if( @inpt.valid? and @inpt.display? )
    @inpt.draw view
    @displayed=true
   else
    @displayed=false
   end
  end

end   #end class SetCompToFront


#function acts as short cut for selecting tool
 def settofront
   Sketchup.active_model.select_tool SetCompToFront.new
 end
 
 #select a ref point on a component and point on component move a distance
 class SetCompRelative #*****************************************************************

  def initialize
   @entity=nil
   @inpt=nil
   @tinpt=nil
   @ip=nil
   @status=0    #status=1 from point, =2 to point
   @poso=nil
   @posn=nil
  end
   
  #is called when first activated
  def activate
   @inpt = Sketchup::InputPoint.new           #set up Input point and temp and diplayed
   @tinpt= Sketchup::InputPoint.new
   @ip= Sketchup::InputPoint.new
   #@displayed = false

   #lets see if any componenent is already selected and clear selection set
   model=Sketchup.active_model
   @ss=model.selection
   @ss.clear
   @entity=nil   

   self.reset(nil)
  end 
  
   #is called if tool is deactivated because a different tool is selected
  def deactivate(view)
   view.invalidate 
  end

  #onCancel is called when user hits escape etc
  def onCancel(flag, view)
    if (flag==2)
     view.invalidate
    else
     self.reset(view)
    end
  end

 #reset to start over again
  def reset(view)
   @status=1
   @displayed=false
   @entity=nil
     Sketchup::set_status_text "Select FROM point ",SB_PROMPT
  end
  
   #cruise for a point in component
  def onMouseMove(flags, x, y, view)
    @tinpt.pick view, x, y
    if (@tinpt.valid?) 
      changed=@tinpt != @inpt
      @inpt.copy! @tinpt 
      view.tooltip = @tinpt.tooltip
      #display point
      if ( changed and (@inpt.display? or @displayed))
       view.invalidate 
      end
    end
  end
  
  def onLButtonDown(flags, x, y, view)
     if @status==1
      @ip.pick view,x,y
      oops=1
      if(@ip.valid?)
	   oops=0
	   @poso=@ip.position
	   #UI.messagebox "x=#{@xo} y=#{@yo} z=#{@zo}"
	   @status=2
	   Sketchup::set_status_text "Select TO point on component ",SB_PROMPT
	  end
      if oops==1
	   UI.messagebox "Point invalid"
      end
	 elsif @status==2
	  ph=view.pick_helper
      ph.do_pick x,y
      @entity=ph.best_picked
	  oops=1
      if @entity
       type=@entity.typename
       if type=="ComponentInstance"
        oops=0
       end
      end
	 if oops==0
	  @ip.pick view,x,y
       oops=1
       if(@ip.valid?)
	    if (@ip.vertex)
         if (@entity.definition==@ip.vertex.parent) 
          oops=0
		 end
	    end	
	   end 	
	  end		
	  if oops==1 
	   UI.messagebox "Selection invalid"
	  else
       @posn=@ip.position
	       idx=@posn.x-@poso.x
		   idy=@posn.y-@poso.y
		   idz=@posn.z-@poso.z
	        prompts = ["Red distance","Green distance", "Blue distance"]
			defaults= [idx.inch,idy.inch,idz.inch]
			results = inputbox prompts, defaults, "Relative Distance"
			if !results then 
			 self.reset(view)
			 return 
			end  #user canceled
			delx=results[0]
			dely=results[1]
			delz=results[2]
			ndx=delx-idx
			ndy=dely-idy
			ndz=delz-idz
            newpos = Geom::Point3d.new ndx, ndy, ndz
	        trans = Geom::Transformation.new newpos
	        status = @entity.transform! trans
			
			self.reset(view)
	  end
    
     end	  
  end
  
  
  #draw is called when we want to display the point
  def draw(view)
   if( @inpt.valid? and @inpt.display? )
    @inpt.draw view
    @displayed=true
   else
    @displayed=false
   end
  end

end   #end class SetCompRelative


#function acts as short cut for selecting tool
 def setrelative
   Sketchup.active_model.select_tool SetCompRelative.new
 end
 
 if( not file_loaded?("setcomponents.rb"))
  #add_separator_to_menu("Draw")
  UI.menu("Tools").add_separator
  UI.menu("Tools").add_item("Set Comp To Front"){settofront}
  UI.menu("Tools").add_item("Set Comp Relative"){setrelative}
 end

 file_loaded("setcomponents.rb")